unit Helios_Font;

{$I Global_Conditionals.INC}

interface

Type
THelios_Font_Letters = record

Unknown1,Unknown2,Unknown3,Unknown4,Unknown5,
Unknown6,Unknown7,Unknown8,Unknown9,Unknown10,
Unknown11,Unknown12 : integer;
Image : String;

end;

THelios_Font = record
Size : Integer;
Letters : array [0..255] of THelios_Font_Letters;
end;

THelios_Fonts = record
Font : array of THelios_Font;
Font_No : Integer;
end;

Var
Fonts : THelios_Fonts;

Function LoadAFont(Filename : String; Size : Integer) : Boolean;
Procedure LoadFonts;

implementation

Uses SysUtils,Dialogs,Helios_Filesystem;

Function LoadFont(Filename : String; Size : Integer; Font : THelios_Font) : Boolean;
var
F : file;
X,Y : Integer;
C : Char;
SF : Boolean;
begin
Result := False;

If not Fileexists(Filename) then exit;

AssignFile(f, filename);
Reset(f,1);

For x := 0 to 255 do
begin

SF := False;
BlockRead(F,Font.Letters[x].Unknown1,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown2,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown3,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown4,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown5,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown6,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown7,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown8,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown9,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown10,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown11,SizeOf(Integer));
BlockRead(F,Font.Letters[x].Unknown12,SizeOf(Integer));

Font.Letters[x].Image := '';
For y := 1 to 32 do
begin
BlockRead(F,C,SizeOf(Char));
If C = #0 then SF := True;

If not SF then
Font.Letters[x].Image := Font.Letters[x].Image + C;
end;

end; // Main Loop

CloseFile(f);

showmessage(Font.Letters[0].Image);

Result := True;
end;

Function LoadAFont(Filename : String; Size : Integer) : Boolean;
var
X : integer;
begin

Result := False;

For x := 0 to Fonts.Font_No-1 do
if Fonts.Font[x].Size = Size then
begin
Result := True;
exit;
end;

Inc(Fonts.Font_No);
SetLength(Fonts.Font,Fonts.Font_No);

Result := LoadFont(Filename,Size,Fonts.Font[Fonts.Font_No-1]);
If Not Result then
begin
Dec(Fonts.Font_No);
SetLength(Fonts.Font,Fonts.Font_No);
end;

end;

Procedure LoadFonts;
begin

Fonts.Font_No := 0;
SetLength(Fonts.Font,Fonts.Font_No);

LoadAFont(DoesFileExist('fonts\fontimage_12.dat'),12);

end;

end.
